"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.downloadSpriggit = void 0;
const http_1 = require("../http/http");
const unzip_1 = require("../zip/unzip");
const path_1 = __importDefault(require("path"));
const fs = __importStar(require("fs"));
const spriggitZipName = 'SpriggitLinuxCLI.zip';
const spriggitZipPath = path_1.default.join('./', spriggitZipName);
const spriggitPath = path_1.default.join('./', 'spriggit');
const spriggitCli = path_1.default.join(spriggitPath, 'Spriggit.CLI');
const downloadSpriggit = (version) => __awaiter(void 0, void 0, void 0, function* () {
    const url = `https://github.com/Mutagen-Modding/Spriggit/releases/download/${version}/${spriggitZipName}`;
    try {
        console.log(`Downloading Spriggit ${version} to ${spriggitZipPath}`);
        yield (0, http_1.downloadFileToDestination)(url, spriggitZipPath);
        console.log(`Successfully downloaded Spriggit ${version}`);
        console.log(`Extracting spriggit to ${spriggitPath}`);
        yield (0, unzip_1.unzipFile)(spriggitZipPath, spriggitPath);
        console.log('Spriggit extracted successfully');
        console.log(`Giving +x permission to ${spriggitCli}`);
        fs.chmodSync(spriggitCli, '755');
    }
    catch (error) {
        console.error('There was an error downloading Spriggit', error);
    }
});
exports.downloadSpriggit = downloadSpriggit;
